--[[
	Druid Cast

	By java aka Express/Toaster

	Es hat mich angekotzt, dass man z.B. versehentlich nicht-Manaklassen
	innervaten kann und Macros spammt, wenn man ein Ziel nicht ressen kann.

	Funktionen als Macros binden!
	/dc innervate	oder /DruidCast innervate
	/dc battleress	oder /DruidCast battleress
	/dc reju	oder /DruidCast reju
	
   ]]


function DruidCast_OnLoad()

	DEFAULT_CHAT_FRAME:AddMessage(DC_LOADING_MSG);

	SLASH_DruidCast1 = "/DruidCast";
	SLASH_DruidCast2 = "/dc";
	SlashCmdList["DruidCast"] = function(msg)
		DruidCast_SlashCommandHandler(msg);
	end
end

function DruidCast_SlashCommandHandler(msg)

	-- Mana Prozentwert ausrechnen
	local DC_MANA = UnitMana("target");
	local DC_MANA_MAX = UnitManaMax("target");
	local DC_MANA_PERCENT = (DC_MANA*100)/DC_MANA_MAX;
	local DC_LEVEL = UnitLevel("target");

	if (string.lower(msg) == "battleress")
	then
		if(UnitIsDeadOrGhost("target") and UnitExists("target") and UnitIsFriend("player","target") and UnitIsPlayer("target")) 
		then 
			CastSpellByName(DC_SPELL_REBIRTH);
			SendChatMessage("<Druid Cast>: " .. DC_RESS_MSG .. " " .. UnitName("target") .. "!", "SAY", GetDefaultLanguage("player"));
			SendChatMessage("<Druid Cast>: " .. DC_REBIRTH_MSG .. "!", "WHISPER", GetDefaultLanguage("player"), UnitName("target"));
		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET3 .. "!");
		end

	elseif (string.lower(msg) == "innervate")
	then
		if(UnitIsFriend("player","target") and UnitIsPlayer("target") and UnitClass("target") ~= DC_CLASS_WARRIOR and UnitClass("target") ~= DC_CLASS_ROGUE and DC_MANA_PERCENT < DC_MANA_CHECK and DC_LEVEL >= 10)
		then
			CastSpellByName(DC_SPELL_INNERVATE);
			SendChatMessage("<Druid Cast>: " .. DC_INNERVATE_MSG2 .. "!", "WHISPER", GetDefaultLanguage("player"), UnitName("target"));
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: " .. DC_INNERVATE_MSG .. " " .. UnitName("target") .. "!");			
		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET2 .. "!");
		end
	
	elseif (string.lower(msg) == "reju")
	then
		if (not UnitIsEnemy("target","player"))
		then
			for i=1,16
			do
				local texture = UnitBuff("target",i); 
				
				if texture ~= nil
				then
					if string.find(string.lower(texture),"rejuvenation")
					then
						DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET4 .. " " .. DC_SPELL_REJU .. "!");
						return end
					else
						break
					end
				end
			end

			CastSpellByName(DC_SPELL_REJU);
	else
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: ".. DC_HELP_MSG .. ":");
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: /dc battleress  /dc innervate  /dc reju");
	end
end	

function DruidCast_OnEvent(event)

end